#define _UNICODE
#define UNICODE
#include <windows.h>
#include <stdio.h>

#define TEST_DIR_PREFIX L"D:\\0\\7\\1\\"

const wchar_t orig_name[] =               TEST_DIR_PREFIX L"test_Far_Original.txt";
const wchar_t dest_name[] =               TEST_DIR_PREFIX L"test_Far_Overwrit.txt";
const wchar_t dest_name_nt[] = L"\\\\?\\" TEST_DIR_PREFIX L"test_Far_Overwrit.txt";

#define orig_size  16652
#define insert_pos 0xC6

char buffer[orig_size+2];

int wmain(int argc, wchar_t **argv)
{
	HANDLE fh;
	DWORD nb = 0;

   if (!CopyFile(orig_name, dest_name, FALSE))
	{ perror("CopyFile failed"); exit(11); } 

	fh = CreateFile(dest_name, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (fh == INVALID_HANDLE_VALUE)
	{ perror("Read create error"); exit(12); } 
	if (!ReadFile(fh, buffer, insert_pos, &nb, NULL) || nb != insert_pos)
	{ perror("Read1 error"); exit(13); } 
	buffer[insert_pos] = buffer[insert_pos+1] = ' ';
	if (!ReadFile(fh, buffer+insert_pos+2, orig_size-insert_pos, &nb, NULL) || nb != orig_size-insert_pos)
	{ perror("Read2 error"); exit(14); } 
	CloseHandle(fh);

	fh = CreateFile(
		dest_name_nt,
		GENERIC_WRITE, FILE_SHARE_READ,
		NULL,
		TRUNCATE_EXISTING,
		FILE_ATTRIBUTE_ARCHIVE | FILE_FLAG_SEQUENTIAL_SCAN | FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_POSIX_SEMANTICS,
		NULL
	);
	if (fh == INVALID_HANDLE_VALUE)
	{ perror("Overwrite create error"); exit(15); } 
	if (!WriteFile(fh, buffer, orig_size+2, &nb, NULL) || nb != orig_size+2)
	{ perror("Write error"); exit(16); } 
	CloseHandle(fh);

	printf("Ok\n");
	(void)argc;
	(void)argv;
	return 0;
}
